﻿Public Class UCDragDrop

    'Property zum Anzeigen des Textes
    Private _labelText As String
    Public Property labelText() As String
        Get
            Return _labelText
        End Get
        Set(ByVal value As String)
            _labelText = value

            Me.Label1.Text = value
        End Set
    End Property

    'Konstruktor
    Public Sub New(ByVal labelText As String)
        InitializeComponent()

        Me.labelText = labelText
    End Sub

    Private Sub UCDragDrop_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragEnter, Label1.DragEnter
        'Überprüfen, ob ein UCDragDrop-Control gedroppt werden soll
        If e.Data.GetDataPresent(GetType(UCDragDrop)) Then
            Dim uD As UCDragDrop = DirectCast(e.Data.GetData(GetType(UCDragDrop)), UCDragDrop)

            'Überprüfen, ob es sich um ein anderes Control handelt
            If Not uD.Equals(Me) Then
                e.Effect = DragDropEffects.Move

                Me.BackColor = Color.Yellow
            End If
        End If
    End Sub

    Private Sub UCDragDrop_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragDrop, Label1.DragDrop
        'das "gedragte" Control casten
        Dim uD As UCDragDrop = DirectCast(e.Data.GetData(GetType(UCDragDrop)), UCDragDrop)

        'den Index des Controls bestimmen, auf das gedroppt wird
        Dim destinationIndex As Integer = Form1.FlowLayoutPanel1.Controls.GetChildIndex(Me)

        'dem gedroppten Control den Index, des Control zuweisen, auf das gedragt wirde
        Form1.FlowLayoutPanel1.Controls.SetChildIndex(uD, destinationIndex)

        'das Control auf das gedroppt wurde um eins nach unten verschieben
        Form1.FlowLayoutPanel1.Controls.SetChildIndex(Me, destinationIndex + 1)

        Me.BackColor = Color.Black
    End Sub

    Private Sub UCDragDrop_DragLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.DragLeave, Label1.DragLeave
        Me.BackColor = Color.Black
    End Sub

    Private Sub UCDragDrop_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown, Label1.MouseDown
        Me.DoDragDrop(Me, DragDropEffects.Move)
    End Sub
End Class
